Index: /trunk/demos/CircleFollower/simulator/src/main.cpp
===================================================================
--- /trunk/demos/CircleFollower/simulator/src/main.cpp	(revision 122)
+++ /trunk/demos/CircleFollower/simulator/src/main.cpp	(revision 123)
@@ -18,5 +18,4 @@
 #include <SimuImu.h>
 #ifdef GL
-#include <SimuCameraGL.h>
 #include <Parser.h>
 #include <Man.h>
@@ -94,6 +93,4 @@
 #ifdef GL
     SimuUsGL* us_gl;
-
-    Camera *cam_av,*cam_bas;
     Parser *gui;
     Man *man;
@@ -106,5 +103,5 @@
 
 #ifdef GL
-    gui=new Parser(simu,960,480,640,480,media_path,scene_file);
+    gui=new Parser(simu,1024,768,1024,768,media_path,scene_file);
 #endif
 
@@ -119,6 +116,5 @@
 #ifdef GL
     us_gl=new SimuUsGL(drone,"us",0);
-    cam_bas=new SimuCameraGL(drone,"bottom camera",320,240,640,0,0);
-    cam_av=new SimuCameraGL(drone,"front camera",320,240,640,240,1);
+    
 
     man=new Man(simu,"target");
Index: /trunk/demos/CircleFollower/uav/CMakeLists.txt
===================================================================
--- /trunk/demos/CircleFollower/uav/CMakeLists.txt	(revision 122)
+++ /trunk/demos/CircleFollower/uav/CMakeLists.txt	(revision 123)
@@ -5,4 +5,5 @@
 SET(FLAIR_USE_FILTER TRUE)
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
+SET(FLAIR_USE_VISION_FILTER TRUE)
 SET(FLAIR_USE_META TRUE)
 SET(FLAIR_USE_VRPN TRUE)
Index: /trunk/demos/Gps/simulator/src/main.cpp
===================================================================
--- /trunk/demos/Gps/simulator/src/main.cpp	(revision 122)
+++ /trunk/demos/Gps/simulator/src/main.cpp	(revision 123)
@@ -19,5 +19,4 @@
 #include <SimuGps.h>
 #ifdef GL
-#include <SimuCameraGL.h>
 #include <Parser.h>
 #include <Man.h>
@@ -96,6 +95,4 @@
 #ifdef GL
     SimuUsGL *us_gl;
-
-    Camera *cam_av,*cam_bas;
     Parser *gui;
     Man *man;
@@ -108,5 +105,5 @@
 
 #ifdef GL
-    gui=new Parser(simu,960,480,640,480,media_path,scene_file);
+    gui=new Parser(simu,1024,768,1024,768,media_path,scene_file);
 #endif
 
@@ -121,7 +118,4 @@
 #ifdef GL
     us_gl=new SimuUsGL(drone,"us",0);
-    cam_bas=new SimuCameraGL(drone,"bottom camera",320,240,640,0,0);
-    cam_av=new SimuCameraGL(drone,"front camera",320,240,640,240,1);
-
     man=new Man(simu,"target");
 #endif
Index: /trunk/demos/Gps/uav/CMakeLists.txt
===================================================================
--- /trunk/demos/Gps/uav/CMakeLists.txt	(revision 122)
+++ /trunk/demos/Gps/uav/CMakeLists.txt	(revision 123)
@@ -5,6 +5,8 @@
 SET(FLAIR_USE_FILTER TRUE)
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
+SET(FLAIR_USE_VISION_FILTER TRUE)
 SET(FLAIR_USE_META TRUE)
 SET(FLAIR_USE_GPS TRUE)
+
 
 include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
Index: /trunk/demos/OpticalFlow/simulator/CMakeLists.txt
===================================================================
--- /trunk/demos/OpticalFlow/simulator/CMakeLists.txt	(revision 122)
+++ /trunk/demos/OpticalFlow/simulator/CMakeLists.txt	(revision 123)
@@ -5,4 +5,5 @@
 SET(FLAIR_USE_SIMULATOR TRUE)
 SET(FLAIR_USE_SIMULATOR_GL TRUE)
+SET(FLAIR_USE_VISION_FILTER TRUE)
 
 include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
Index: /trunk/demos/OpticalFlow/uav/CMakeLists.txt
===================================================================
--- /trunk/demos/OpticalFlow/uav/CMakeLists.txt	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/CMakeLists.txt	(revision 123)
@@ -4,6 +4,6 @@
 SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
 SET(FLAIR_USE_FILTER TRUE)
-#SET(FLAIR_USE_VISION_FILTER TRUE)
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
+SET(FLAIR_USE_VISION_FILTER TRUE)
 SET(FLAIR_USE_META TRUE)
 
Index: /trunk/demos/OpticalFlow/uav/src/main.cpp
===================================================================
--- /trunk/demos/OpticalFlow/uav/src/main.cpp	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/src/main.cpp	(revision 123)
@@ -18,5 +18,5 @@
 #include <tclap/CmdLine.h>
 #include <TargetEthController.h>
-#include <init.h>
+#include <VisionFilter.h>
 
 using namespace TCLAP;
@@ -41,4 +41,8 @@
     parseOptions(argc,argv);
 
+		if(!InitVisionFilter("file="+dsp_file)) {
+			exit(1);
+		}
+		
     FrameworkManager *manager;
     manager= new FrameworkManager(name);
@@ -46,5 +50,4 @@
     manager->SetupUserInterface(xml_file);
     manager->SetupLogger(log_path);
-    SetupDSP(dsp_file);
 
     Uav* drone=CreateUav(name,uav_type);
@@ -57,5 +60,5 @@
     delete manager;
 
-    CloseDSP();
+    CloseVisionFilter();
 }
 
Index: /trunk/demos/SimpleFleet/uav/CMakeLists.txt
===================================================================
--- /trunk/demos/SimpleFleet/uav/CMakeLists.txt	(revision 122)
+++ /trunk/demos/SimpleFleet/uav/CMakeLists.txt	(revision 123)
@@ -5,4 +5,5 @@
 SET(FLAIR_USE_FILTER TRUE)
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
+SET(FLAIR_USE_VISION_FILTER TRUE)
 SET(FLAIR_USE_META TRUE)
 SET(FLAIR_USE_VRPN TRUE)
Index: /trunk/demos/Skeletons/CustomReferenceAngles/CMakeLists.txt
===================================================================
--- /trunk/demos/Skeletons/CustomReferenceAngles/CMakeLists.txt	(revision 122)
+++ /trunk/demos/Skeletons/CustomReferenceAngles/CMakeLists.txt	(revision 123)
@@ -5,4 +5,5 @@
 SET(FLAIR_USE_FILTER TRUE)
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
+SET(FLAIR_USE_VISION_FILTER TRUE)
 SET(FLAIR_USE_META TRUE)
 
Index: /trunk/demos/Skeletons/CustomTorques/CMakeLists.txt
===================================================================
--- /trunk/demos/Skeletons/CustomTorques/CMakeLists.txt	(revision 122)
+++ /trunk/demos/Skeletons/CustomTorques/CMakeLists.txt	(revision 123)
@@ -5,4 +5,5 @@
 SET(FLAIR_USE_FILTER TRUE)
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
+SET(FLAIR_USE_VISION_FILTER TRUE)
 SET(FLAIR_USE_META TRUE)
 
Index: /trunk/lib/FlairCore/src/FrameworkManager.cpp
===================================================================
--- /trunk/lib/FlairCore/src/FrameworkManager.cpp	(revision 122)
+++ /trunk/lib/FlairCore/src/FrameworkManager.cpp	(revision 123)
@@ -174,4 +174,7 @@
 }
 
+string FrameworkManager::GetLogPath(void) const {
+	return pimpl_->log_path;
+}
 void FrameworkManager::AddDeviceToLog(IODevice *device) {
   pimpl_->AddDeviceToLog(device);
Index: /trunk/lib/FlairCore/src/FrameworkManager.h
===================================================================
--- /trunk/lib/FlairCore/src/FrameworkManager.h	(revision 122)
+++ /trunk/lib/FlairCore/src/FrameworkManager.h	(revision 123)
@@ -109,4 +109,13 @@
   */
   void SetupLogger(std::string log_path);
+	
+	/*!
+  * \brief Get log path
+  *
+	* get the path defined by SetupLogger
+  *
+  * \return log path
+  */
+  std::string GetLogPath(void) const;
 
   /*!
Index: /trunk/lib/FlairSensorActuator/CMakeLists.txt
===================================================================
--- /trunk/lib/FlairSensorActuator/CMakeLists.txt	(revision 122)
+++ /trunk/lib/FlairSensorActuator/CMakeLists.txt	(revision 123)
@@ -23,7 +23,7 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/src/unexported
 	${CMAKE_CURRENT_SOURCE_DIR}/../FlairCore/src
+	${CMAKE_CURRENT_SOURCE_DIR}/../FlairVisionFilter/src
 	${CMAKE_SYSROOT}/usr/include/opencv
 	${CMAKE_SYSROOT}/usr/include/vrpn
-#	$ENV{IGEP_ROOT}/uav_dev/include
 )
 
Index: /trunk/lib/FlairSensorActuator/src/Camera.cpp
===================================================================
--- /trunk/lib/FlairSensorActuator/src/Camera.cpp	(revision 122)
+++ /trunk/lib/FlairSensorActuator/src/Camera.cpp	(revision 123)
@@ -24,4 +24,5 @@
 #include <DataPlot1D.h>
 #include <Picture.h>
+#include <VisionFilter.h>
 #include <highgui.h>
 #include <fstream>
@@ -118,5 +119,6 @@
 			case LogFormat::JPG:
 					IplImage *img=((cvimage*)data)->img;
-					//dspSaveToJpeg(img,"toto");
+					string filename=getFrameworkManager()->GetLogPath()+"/"+ObjectName()+"_"+std::to_string(data->DataTime())+".jpg";
+					saveToJpeg(img,filename);
 				break;
 		}
Index: /trunk/lib/FlairVisionFilter/CMakeLists.txt
===================================================================
--- /trunk/lib/FlairVisionFilter/CMakeLists.txt	(revision 122)
+++ /trunk/lib/FlairVisionFilter/CMakeLists.txt	(revision 123)
@@ -21,4 +21,5 @@
 	${LIBXML2_INCLUDE_DIR}
 	${CMAKE_CURRENT_SOURCE_DIR}/src
+	${CMAKE_CURRENT_SOURCE_DIR}/src/unexported
 	$ENV{FLAIR_ROOT}/flair-src/lib/FlairCore/src
 	${CMAKE_SYSROOT}/usr/include/opencv
Index: /trunk/lib/FlairVisionFilter/src/VisionFilter.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/VisionFilter.cpp	(revision 123)
+++ /trunk/lib/FlairVisionFilter/src/VisionFilter.cpp	(revision 123)
@@ -0,0 +1,22 @@
+#include "VisionFilter.h"
+#include "compile_info.h"
+#include <highgui.h>
+
+static void constructor() __attribute__((constructor));
+
+void constructor() {
+  compile_info("FlairVisionFilter");
+}
+
+void saveToJpeg(IplImage* src_img,std::string filename,unsigned char compression_level) {
+	if(!cvSaveImage(filename.c_str(),src_img)) printf("Could not save.\n");
+}
+
+bool InitVisionFilter(std::string args) {
+  printf("Using default vision lib filter, all functions are not ready!\n");
+	return true;
+}
+
+void CloseVisionFilter(void) {
+  
+}
Index: /trunk/lib/FlairVisionFilter/src/VisionFilter.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/VisionFilter.h	(revision 123)
+++ /trunk/lib/FlairVisionFilter/src/VisionFilter.h	(revision 123)
@@ -0,0 +1,14 @@
+#include <string>
+#include <cxtypes.h>
+
+/*!
+* \brief InitVisionFilter
+*
+* \return true
+*/
+
+bool InitVisionFilter(std::string args);
+
+void CloseVisionFilter(void);
+
+void saveToJpeg(IplImage* src_img,std::string filename,unsigned char compression_level=95);
Index: unk/lib/FlairVisionFilter/src/init.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/init.cpp	(revision 122)
+++ 	(revision )
@@ -1,10 +1,0 @@
-#include "init.h"
-
-
-void SetupDSP(std::string file,int globalTimeoutMs) {
-    
-}
-
-void CloseDSP(void) {
-  
-}
Index: unk/lib/FlairVisionFilter/src/init.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/init.h	(revision 122)
+++ 	(revision )
@@ -1,16 +1,0 @@
-#include <string>
-
-/*!
-* \brief DSP setup
-*
-* Setup DSP executable file. \n
-* If this method is not called, no DSP processing will be available. \n
-*
-* \param file DSP executable file
-* \param globalTimeoutMs timeout for all DSP functions, in ms (timeout is only
-* used to display a warning. -1 to disable timeout
-*/
-void SetupDSP(std::string file,int globalTimeoutMs=-1);
-
-
-void CloseDSP(void);
Index: /trunk/lib/FlairVisionFilter/src/unexported/compile_info.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/unexported/compile_info.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/unexported/compile_info.h	(revision 123)
@@ -5,9 +5,9 @@
 
 #define USER "gsanahuj@gsanahuj-Latitude-E6420"
-#define DATE "vendredi 6 janvier 2017, 12:43:09 (UTC+0100)"
+#define DATE "mardi 10 janvier 2017, 15:56:33 (UTC+0100)"
 #define GCC_REV "4.9.1"
 #define GCC_PATH "/opt/robomap3/1.7.3/armv7a-neon/sysroots/x86_64-pokysdk-linux/usr/bin/arm-poky-linux-gnueabi/arm-poky-linux-gnueabi-gcc"
 #define SVN_PATH "/home/gsanahuj/HDS/igep/flair-src_svn/trunk/lib/FlairVisionFilter"
-#define SVN_REV "Ajout, copie ou déplacement local non propagé"
+#define SVN_REV "122M"
 
 inline void compile_info(std::string name) { 